basic
来自「实战Linux编程的原代码,希望对学驱动的人能有所帮助」· 代码 · 共 88 行
TXT
88 行
#!/bin/sh# Compare actual numbers from du, assuming block size matches mine.if test "$VERBOSE" = yes; then set -x du --versionfi# DU_BLOCK_SIZE could cause problems. $srcdir/../envvar-check. $srcdir/../lang-defaultpwd=`pwd`t0=`echo "$0"|sed 's,.*/,,'`.tmp; tmp=$t0/$$trap 'status=$?; cd $pwd; chmod -R u+rwx $t0; rm -rf $t0 && exit $status' 0trap '(exit $?); exit $?' 1 2 13 15framework_failure=0mkdir -p $tmp || framework_failure=1cd $tmp || framework_failure=1mkdir -p a/b d d/sub || framework_failure=1printf 'make-sure-the-file-is-non-empty\n' > a/b/F || framework_failure=1# Ensure that these files contain more than 64 bytes, so that we don't# immediately disqualify file systems (e.g., NetApp) on which smaller# files take up zero disk blocks.seq --format=%100g 1 90 | head --bytes=4k > d/1cp d/1 d/sub/2if test $framework_failure = 1; then echo "$0: failure in testing framework" 1>&2 (exit 1); exit 1fi# Ensure that blocksize and block-count are what we expect for directories.if test "`stat --format=%bx%B a`" != 8x512; then echo "$0: different block count/size, so skipping this test" 1>&2 (exit 77); exit 77fi# Ensure that blocksize and block-count are what we expect for files.if test "`stat --format=%bx%B d/1`" != 8x512; then echo "$0: different block count/size, so skipping this test" 1>&2 (exit 77); exit 77fifail=0du -a a > out || fail=1echo === >> outdu -a -S a >> out || fail=1echo === >> outdu -s a >> out || fail=1cat <<\EOF | sed 's/ *#.*//' > exp4 a/b/F8 a/b12 a===4 a/b/F # size of file, a/b/F8 a/b # size of dir entry, a/b, + size of file, a/b/F4 a # size of dir entry, a===12 aEOFcmp out exp || fail=1test $fail = 1 && diff -u out exp 2> /dev/nullrm -f out expdu -a d | sort -r -k2,2 > out || fail=1echo === >> outdu -S d | sort -r -k2,2 >> out || fail=1cat <<\EOF | sed 's/ *#.*//' > exp4 d/sub/28 d/sub4 d/116 d===8 d/sub8 d # d + d/1; don't count the dir. entry for d/subEOFcmp out exp || fail=1test $fail = 1 && diff out exp 2> /dev/null(exit $fail); exit $fail
⌨️ 快捷键说明
复制代码Ctrl + C
搜索代码Ctrl + F
全屏模式F11
增大字号Ctrl + =
减小字号Ctrl + -
显示快捷键?